diff --git a/pgadmin/include/debugger/dbgConst.h b/pgadmin/include/debugger/dbgConst.h
index d8b6e9e..5075616 100644
--- a/pgadmin/include/debugger/dbgConst.h
+++ b/pgadmin/include/debugger/dbgConst.h
@@ -18,16 +18,63 @@
 #ifndef DBGCONST_H
 #define DBGCONST_H
 
-const int 	ID_BTNNEXT	   = 1800;
-const int  	ID_GRDFUNCARGS = 1810;
-const int  	ID_TXTMESSAGE  = 1820;
-const int  	ID_TIMER	   = 1830;
-const int  	ID_BTNCANCEL   = 1840;
+const int      ID_BTNNEXT     = 1800;
+const int      ID_GRDFUNCARGS = 1810;
+const int      ID_TXTMESSAGE  = 1820;
+const int      ID_TIMER       = 1830;
+const int      ID_BTNCANCEL   = 1840;
 
-const int  	ID_PARAMGRID   = 1000;
-const int  	ID_VARGRID	   = 1001;
-const int 	ID_MSG_PAGE	   = 1002;
-const int	ID_PKGVARGRID  = 1003;
+const int      ID_PARAMGRID   = 1000;
+const int      ID_VARGRID     = 1001;
+const int      ID_MSG_PAGE    = 1002;
+const int      ID_PKGVARGRID  = 1003;
 
-#endif
+enum
+{
+	MENU_ID_EXECUTE = 10001,            // Execute command entered by user
+
+	MENU_ID_TOGGLE_BREAK,               // Set/Unset breakpoint
+	MENU_ID_CLEAR_ALL_BREAK,            // Clear all breakpoints
+	MENU_ID_CONTINUE,                   // Continue
+	MENU_ID_STEP_OVER,                  // Step over
+	MENU_ID_STEP_INTO,                  // Step into
+	MENU_ID_STOP,                       // Stop debugging
+
+	MENU_ID_START_DEBUGGING,            // Spawn a separate debugger process
+	MENU_ID_NOTICE_RECEIVED,            // NOTICE received from server
+	WINDOW_ID_STACK,                    // Tree-control window
+	WINDOW_ID_CONSOLE,                  // Console window
+	WINDOW_ID_TABS,                     // Tab window
+	WINDOW_ID_BREAKPOINTS,              // Breakpoints window
+	WINDOW_ID_RESULT_GRID,              // Results window
+	WINDOW_ID_COMMAND,                  // Command window
+	SOCKET_ID_DEBUG,                    // Debugger Socket ID
+
+	MENU_ID_VIEW_TOOLBAR,               // View menu options
+	MENU_ID_VIEW_STACKPANE,
+	MENU_ID_VIEW_OUTPUTPANE,
+	MENU_ID_VIEW_DEFAULTVIEW,
+
+	RESULT_ID_ATTACH_TO_PORT,           // Debugger - attach to port completed
+	RESULT_ID_BREAKPOINT,               // Debugger - breakpoint reached
+	RESULT_ID_GET_VARS,                 // Debugger - variable list complete
+	RESULT_ID_GET_STACK,                // Debugger - stack trace complete
+	RESULT_ID_GET_BREAKPOINTS,          // Debugger - breakpoint list complete
+	RESULT_ID_NEW_BREAKPOINT,           // Debugger - set breakpoint complete
+	RESULT_ID_NEW_BREAKPOINT_WAIT,      // Debugger - set breakpoint complete, wait for target progress
+	RESULT_ID_DEL_BREAKPOINT,           // Debugger - drop breakpoint complete
+	RESULT_ID_DEPOSIT_VALUE,            // Debugger - deposit value complete
+	RESULT_ID_ADD_BREAKPOINT,           // Debugger - target info received, now set a breakpoint
+	RESULT_ID_LISTENER_CREATED,         // Debugger - global listener created
+	RESULT_ID_TARGET_READY,             // Debugger - target session attached
+	RESULT_ID_LAST_BREAKPOINT,          // Debugger - last breakpoint created
+	RESULT_ID_ARGS_UPDATED,             // Debugger - Values are evaluated and been updated in the arguments
+	RESULT_ID_ARGS_UPDATE_ERROR,        // Debugger - Error while evaluateling the value for the arguments
 
+	RESULT_ID_DIRECT_TARGET_COMPLETE,   // DirectDebug - target function complete
+
+	ID_DEBUG_INITIALIZER               // Debugger - debug package initializer? checkbox
+
+};
+
+#endif
diff --git a/pgadmin/include/debugger/dbgTargetInfo.h b/pgadmin/include/debugger/dbgTargetInfo.h
index 5649513..ece98a4 100644
--- a/pgadmin/include/debugger/dbgTargetInfo.h
+++ b/pgadmin/include/debugger/dbgTargetInfo.h
@@ -11,57 +11,103 @@
 #ifndef DBGTARGETINFO_H
 #define DBGTARGETINFO_H
 
+#include <wx/wx.h>
+#include "db/pgConn.h"
+#include "db/pgQueryThread.h"
+
+
 ////////////////////////////////////////////////////////////////////////////////
-// class wsArgInfo
+// class dbgArgInfo
 //
-//	A wsArgInfo object contains information about a function (or procedure)
+//	A dbgArgInfo object contains information about a function (or procedure)
 //  argument.  Inside of each wsArgInfo object, we store the name of the argument,
 //	the argument type, and the argument mode (IN (i), OUT (o), or INOUT (b)).
 //
 //	Once the user has had a chance to enter values for each of the IN and INOUT
 //	arguments, we store those values inside of the corresponding wsArgInfo objects
-
-class wsArgInfo
+class dbgArgInfo
 {
 public:
-	wsArgInfo( const wxString &argName, const wxString &argType, const wxString &argMode, const wxString &argTypeOid );
+	dbgArgInfo(const wxString &_name, const wxString &_type, Oid _typeOid,
+	           short _mode = pgParam::PG_PARAM_IN);
 
-	const wxString &getName()
+	Oid             GetType()
 	{
-		return m_name;
+		return m_typeOid;
 	}
-	const wxString &getType()
+	const wxString &GetTypeName()
 	{
 		return m_type;
 	}
-	const wxString &getMode()
+	wxString       &GetName()
+	{
+		return m_name;
+	}
+	short           GetMode()
 	{
 		return m_mode;
 	}
-	const Oid getTypeOid()
+	bool            IsArray()
 	{
-		return m_typeOid;
+		return !(m_baseType.IsEmpty());
+	}
+	const wxString &GetBaseType()
+	{
+		return m_baseType;
+	}
+	bool           &Null()
+	{
+		return m_null;
+	}
+	wxString       &Value()
+	{
+		return m_val;
+	}
+
+	void            SetDefault(const wxString &val)
+	{
+		m_hasDefault = true;
+		m_defValue = val;
 	}
-	wxString &getValue()
+	wxString       &Default()
 	{
-		return m_value;    // NOTE: non-const, caller may modifiy value
+		return m_defValue;
 	}
-	const wxString   quoteValue();
-	bool isValidDefVal( const wxString defvalue );
-	void  setValue( const wxString &newValue )
+	bool            HasDefault()
 	{
-		m_value = newValue;
+		return m_hasDefault;
 	}
+	bool           &UseDefault()
+	{
+		return m_useDefault;
+	}
+
+	pgParam *GetParam(wxMBConv *_conv = NULL);
 
 private:
-	wxString	m_name;
-	wxString	m_type;
-	wxString	m_mode;
-	wxString	m_value;
-	Oid         m_typeOid;
+	dbgArgInfo(const dbgArgInfo &_arg)
+	{
+		wxASSERT(0);
+	}
+
+	dbgArgInfo &operator= (const dbgArgInfo &)
+	{
+		wxASSERT(0);
+	}
+
+	wxString   m_name;       /* Name of the argument */
+	wxString   m_type;       /* Type of the argument */
+	wxString   m_baseType;   /* Base type of an array type */
+	wxString   m_defValue;   /* Default Value */
+	Oid        m_typeOid;    /* OID of Type */
+	short      m_mode;       /* IN, IN OUT, OUT, or VARAIDIC */
+	bool       m_hasDefault; /* Has the default value? */
+	bool       m_useDefault; /* Use the default value? */
+	bool       m_null;       /* Is Value NULL */
+	wxString   m_val;        /* Value */
 };
 
-WX_DECLARE_OBJARRAY(wsArgInfo, wsArgInfoArray);
+WX_DEFINE_ARRAY_PTR(dbgArgInfo *, pgDbgArgs);
 
 ////////////////////////////////////////////////////////////////////////////////
 // class dbgTargetInfo
@@ -82,95 +128,120 @@ WX_DECLARE_OBJARRAY(wsArgInfo, wsArgInfoArray);
 //
 //	This class offers a number of (inline) member functions that you can call
 //  to extract the above information after it's been queried from the server.
-
-class dbgPgConn;
-
+//
 class dbgTargetInfo
 {
 public:
-	dbgTargetInfo( const wxString &target, dbgPgConn *conn, char targetType );
+	dbgTargetInfo(Oid _target, pgConn *_conn);
 
-	int	getArgInCount()
+	const wxString &GetQualifiedName()
 	{
-		return( m_argInCount );
+		return m_fqName;
 	}
-	int 	getArgOutCount()
+
+	const wxString &GetLanguage()
 	{
-		return( m_argOutCount );
+		return m_language;
 	}
-	int 	getArgInOutCount()
+
+	const wxString &GetPackageName()
 	{
-		return( m_argInOutCount );
+		return m_package;
 	}
-	int	getArgCount()
+	const wxString &GetSchemaName()
 	{
-		return( m_argInCount + m_argOutCount + m_argInOutCount );
+		return m_schema;
 	}
 
-	const wxString &getLanguage()
+	const wxString &GetName()
 	{
-		return( m_language );
+		return m_name;
 	}
-	const wxString &getSchema()
+
+	const wxString &GetReturnType()
 	{
-		return( m_schema );
+		return m_returnType;
 	}
-	const wxString &getName()
+
+	long GetOid()
 	{
-		return( m_name );
+		return m_oid;
 	}
-	const wxString &getFQName()
+
+	long GetPkgOid()
 	{
-		return( m_fqName );
+		return m_pkgOid;
 	}
-	const wxString &getReturnType()
+
+	long GetSchemaOid()
 	{
-		return( m_returnType );
+		return m_schemaOid;
 	}
-	long	getOid()
+
+	long GetPkgInitOid()
 	{
-		return( m_oid );
+		return m_pkgInitOid;
 	}
-	long	getPkgOid()
+
+	bool GetIsFunction()
 	{
-		return( m_pkgOid );
+		return m_isFunction;
 	}
-	long	getPkgInitOid()
+
+	bool GetReturnsSet()
 	{
-		return( m_pkgInitOid );
+		return m_returnsSet;
 	}
-	bool	getIsFunction()
+
+	bool RequireUserInput()
 	{
-		return( m_isFunction );
+		return ((m_pkgOid != 0 && m_pkgInitOid != 0) || m_inputParamCnt != 0);
 	}
-	bool	getReturnsSet()
+
+	bool &DebugPackageConstructor()
 	{
-		return( m_returnsSet );
+		return m_debugPkgCon;
 	}
 
-	wsArgInfo &operator[]( int index );
+	dbgArgInfo *operator[](int index);
+
+	pgDbgArgs *GetArgs()
+	{
+		return m_args;
+	}
+
+	bool HasVariadic()
+	{
+		return m_hasVariadic;
+	}
+
+	bool AddForExecution(pgQueryThread *_thread);
 
 private:
-	wxString	m_name;		 // Target name (function or procedure)
-	wxString	m_schema;	 // Schema in which target resides
-	wxString	m_language;	 // Language in which target is defined
-	wxString	m_argNames;	 // Argument names
-	wxString	m_argModes;	 // Argument modes
-	wxString	m_argTypes;	 // Argument types
-	wxString	m_argTypeOids; // Argument type OIDs
-	wxString	m_argDefVals;  // Argument default values
-	wxString	m_fqName;	 // Fully-qualified name (schema.package.func or package.func)
-	wxString    m_returnType;// Return type
-	bool	m_isFunction;	 // true->target is a function, false->target is a procedure
-	bool    m_returnsSet;    // Returns a set?
-	int	m_argInCount;	 // Number of IN arguments
-	int	m_argOutCount;	 // Number of OUT arguments
-	int	m_argInOutCount; // Number of INOUT arguments
-	long	m_oid;		 // Target function/procedure OID
-	long	m_pkgOid;	 // Package in which target defined (if non-zero)
-	long    m_pkgInitOid; // OID of the package initializer function.
-	wsArgInfoArray	m_argInfo;
+	wxString   m_name;          // Target name (function or procedure)
+	wxString   m_schema;        // Schema in which target resides
+	wxString   m_package;       // Package in which target resides
+	wxString   m_language;      // Language in which target is defined
+
+	wxString   m_returnType;    // Return type
+	wxString   m_funcSignature; // Function Signature
+
+	wxString   m_fqName;        // Function qualified name
+
+	bool       m_isFunction;    // true->target is a function, false->target is a procedure
+	bool       m_returnsSet;    // Returns a set?
+	bool       m_hasVariadic;   // Has the variadic argument
+
+	bool       m_debugPkgCon;    // Debug Package Constructor
+
+	long       m_oid;           // Target function/procedure OID
+	long       m_pkgOid;        // Package in which target defined (if non-zero)
+	long       m_pkgInitOid;    // OID of the package initializer function.
+	long       m_schemaOid;     // OID of the schema
+
+	size_t     m_inputParamCnt; // IN/IN OUT parameter count
 
+	pgDbgArgs *m_args;          // Function arguments
 };
 
 #endif
diff --git a/pgadmin/include/debugger/dlgDirectDbg.h b/pgadmin/include/debugger/dlgDirectDbg.h
index d44ff2d..cd15e3a 100644
--- a/pgadmin/include/debugger/dlgDirectDbg.h
+++ b/pgadmin/include/debugger/dlgDirectDbg.h
@@ -27,71 +27,98 @@
 //
 ////////////////////////////////////////////////////////////////////////////////
 
-#ifndef DBGDIRECT_H
-#define DBGDIRECT_H
+#ifndef DLGDIRECTDBG_H
+#define DLGDIRECTDBG_H
+
+#include <wx/wx.h>
+#include <wx/grid.h>
+#include <wx/strconv.h>
 
 #include "dlg/dlgClasses.h"
-#include "debugger/dbgBreakPoint.h"
-#include "debugger/dbgConnProp.h"
-#include "debugger/frmDebugger.h"
 
-class dbgTargetInfo;
-class dbgPgConn;
-class ctlCodeWindow;
+class dbgArgInfo;
+class frmDebugger;
+class dbgController;
 
-class dlgDirectDbg : public pgDialog
+class ctlGridCellBoolEditor : public wxGridCellBoolEditor
 {
-	DECLARE_CLASS( dlgDirectDbg )
-
 public:
+	ctlGridCellBoolEditor(dbgArgInfo *_arg = NULL);
+	void BeginEdit (int _row, int _col, wxGrid *_grid);
+	wxGridCellEditor *Clone() const;
 
-	dlgDirectDbg( frmDebugger *parent, wxWindowID id, const dbgConnProp &connProp );
-	dbgBreakPointList &getBreakpointList();
-	void setupParamWindow();
-	bool startDebugging();
-	bool GetCancelled()
+	dbgArgInfo *GetArg()
 	{
-		return m_cancelled;
-	};
+		return m_arg;
+	}
 
 private:
+	dbgArgInfo *m_arg;
+};
+
+class dlgDirectDbg;
+
+class dbgArgValueEvaluator : public wxThread
+{
+public:
+	dbgArgValueEvaluator(pgConn *, dlgDirectDbg *);
+
+	void *Entry();
+	void  CancelEval();
+	static void NoticeHandler(void *, const char *);
+
+private:
+	pgConn       *m_conn;
+	dlgDirectDbg *m_dlg;
+
+	bool          m_cancelled;
+};
+
+
+class dlgDirectDbg : public pgDialog
+{
+	DECLARE_CLASS(dlgDirectDbg)
+
+public:
+	dlgDirectDbg(frmDebugger *_parent, dbgController *_controller,
+	             pgConn *_conn);
 
 	enum
 	{
-	    COL_NAME = 0,	// Column 0 contains the variable name
-	    COL_TYPE,	// This column contains the variable type
-	    COL_VALUE	// This column contains the variable value
+		COL_NAME = 0, // Column 0 contains the variable name
+		COL_TYPE,     // Type of column
+		COL_NULL,     // Value Set to NULL (yes/no)
+		COL_EXPR,     // Value is an expression (yes/no)
+		COL_VALUE,    // Value (constant ,or an expression)
+		COL_USE_DEF,  // Use the default value
+		COL_DEF_VAL   // Default value for the column
 	};
 
-	wxString	m_target;	// Target name (function/procedure signature or OID)
-	bool		m_isFunc;
-	const dbgConnProp &m_connProp;	// Connection properties (used to connect to the server)
-	dbgTargetInfo     *m_targetInfo;	// Detailed information about the target (like argument types, name, ...)
-	dbgPgConn         *m_conn;		// The connection to the server
-	ctlCodeWindow     *m_codeWindow;		// A pointer to the debugger window that we'll create
-	dbgBreakPointList m_breakpoints;		// List of initial breakpoints to create
-	frmDebugger		 *m_parent;
-	bool m_cancelled;
-
-	bool loadTargetInfo( const wxString &target, const dbgConnProp &connProp, char targetType );
-	void populateParamGrid();
-	void OnOk( wxCommandEvent &event );
-	void OnCancel( wxCommandEvent &event );
-	void OnClose( wxCloseEvent &event );
-	void OnTargetComplete( wxCommandEvent &event );
-	void OnDebug( wxCommandEvent &event );
-	void OnNoticeReceived( wxCommandEvent &event );
-	bool activateDebugger( );
-
-	void saveSettings();
-	void loadSettings();
-	void setBreakpoint( long pkgOid, long funcOid );
-	void invokeTarget();
-	void invokeTargetCallable();
-	void invokeTargetStatement();
+private:
 
-	DECLARE_EVENT_TABLE()
+	void PopulateParamGrid();
 
+	void OnOk(wxCommandEvent &event);
+	void OnCancel(wxCommandEvent &event);
+	void OnClickGridLabel(wxGridEvent &event);
+
+	void ResultArgsUpdated(wxCommandEvent &);
+	void ResultArgsUpdateError(wxCommandEvent &);
+
+	void SaveSettings();
+	void LoadSettings();
+	void LoadLastCellSetting(int row_number, int array_row_number, int index_number, bool isArray); // Function to retrive last cell value if the provieded parameter value is an invalid.
+
+	wxGrid *GetParamsGrid();
+	bool DebugPkgConstructor();
+
+	dbgController        *m_controller;
+	pgConn               *m_conn;
+	dbgArgValueEvaluator *m_thread;
+
+	friend class dbgArgValueEvaluator;
+
+	DECLARE_EVENT_TABLE()
 };
 
 #endif
diff --git a/pgadmin/include/debugger/frmDebugger.h b/pgadmin/include/debugger/frmDebugger.h
index 11c444f..0c7801a 100644
--- a/pgadmin/include/debugger/frmDebugger.h
+++ b/pgadmin/include/debugger/frmDebugger.h
@@ -24,11 +24,7 @@
 #define FRMDEBUGGER_H
 
 #include <wx/aui/aui.h>
-
-#include "ctl/ctlSQLBox.h"
-#include "frm/frmMain.h"
-#include "debugger/dbgConnProp.h"
-#include "debugger/ctlTabWindow.h"
+#include <wx/progdlg.h>
 
 //
 // This number MUST be incremented if changing any of the default perspectives
@@ -45,113 +41,139 @@
 #endif
 #endif
 
-enum
-{
-    MENU_ID_EXECUTE = 10001,            // Execute command entered by user
-
-    MENU_ID_TOGGLE_BREAK,               // Set/Unset breakpoint
-    MENU_ID_CLEAR_ALL_BREAK,            // Clear all breakpoints
-    MENU_ID_CONTINUE,                   // Continue
-    MENU_ID_STEP_OVER,                  // Step over
-    MENU_ID_STEP_INTO,                  // Step into
-    MENU_ID_STOP,                       // Stop debugging
-
-    MENU_ID_SPAWN_DEBUGGER,             // Spawn a separate debugger process
-    MENU_ID_NOTICE_RECEIVED,            // NOTICE received from server
-    WINDOW_ID_STACK,                    // Tree-control window
-    WINDOW_ID_CONSOLE,                  // Console window
-    WINDOW_ID_TABS,                     // Tab window
-    WINDOW_ID_BREAKPOINTS,              // Breakpoints window
-    WINDOW_ID_RESULT_GRID,              // Results window
-    WINDOW_ID_COMMAND,                  // Command window
-    SOCKET_ID_DEBUG,                    // Debugger Socket ID
-
-    MENU_ID_VIEW_TOOLBAR,               // View menu options
-    MENU_ID_VIEW_STACKPANE,
-    MENU_ID_VIEW_OUTPUTPANE,
-    MENU_ID_VIEW_DEFAULTVIEW,
-
-    RESULT_ID_ATTACH_TO_PORT,           // Debugger - attach to port completed
-    RESULT_ID_BREAKPOINT,               // Debugger - breakpoint reached
-    RESULT_ID_GET_VARS,                 // Debugger - variable list complete
-    RESULT_ID_GET_STACK,                // Debugger - stack trace complete
-    RESULT_ID_GET_BREAKPOINTS,          // Debugger - breakpoint list complete
-    RESULT_ID_GET_SOURCE,               // Debugger - source code listing complete
-    RESULT_ID_NEW_BREAKPOINT,           // Debugger - set breakpoint complete
-    RESULT_ID_NEW_BREAKPOINT_WAIT,      // Debugger - set breakpoint complete, wait for target progress
-    RESULT_ID_DEL_BREAKPOINT,           // Debugger - drop breakpoint complete
-    RESULT_ID_DEPOSIT_VALUE,            // Debugger - deposit value complete
-    RESULT_ID_ABORT_TARGET,             // Debugger - abort target (cancel function)
-    RESULT_ID_ADD_BREAKPOINT,           // Debugger - target info received, now set a breakpoint
-    RESULT_ID_LISTENER_CREATED,         // Debugger - global listener created
-    RESULT_ID_TARGET_READY,             // Debugger - target session attached
-    RESULT_ID_LAST_BREAKPOINT,          // Debugger - last breakpoint created
-
-    RESULT_ID_DIRECT_TARGET_COMPLETE,   // DirectDebug - target function complete
-
-    ID_DEBUG_INITIALIZER,               // Debugger - debug package initializer? checkbox
-};
-
+// Debugger Controller
+class dbgController;
+class frmMain;
+class ctlTabWindow;
 class ctlResultGrid;
 class ctlVarWindow;
-class ctlCodeWindow;
-class dlgDirectDbg;
-class wxSizeReportCtrl;
+class ctlSQLBox;
+class dbgCachedStack;
 
 class frmDebugger : public pgFrame
 {
-	DECLARE_CLASS( frmDebugger )
+	DECLARE_CLASS(frmDebugger)
 
 public:
-	frmDebugger(frmMain *parent, const wxString &title);
+	frmDebugger(frmMain *_parent, dbgController *_controller,
+	            const wxString &_title);
 	virtual ~frmDebugger();
 
-	dlgDirectDbg   *addDirectDbg( const dbgConnProp &connProp );        // Create a new direct-debugging window
-	ctlCodeWindow  *addDebug( const dbgConnProp &props );               // Create a new debugger window
-	wxStatusBar   *getStatusBar()
+	void SetupDebugger();
+
+	void SetStatusText(const wxString &_status);
+
+	ctlTabWindow *GetTabWindow()
 	{
-		return( m_statusBar );    // Returns pointer to the status bar
+		return m_tabWindow;
+	}
+	ctlStackWindow *GetStackWindow()
+	{
+		return m_stackWindow;
+	}
+	ctlMessageWindow *GetMessageWindow()
+	{
+		return m_tabWindow->GetMessageWindow();
 	}
 
-	wxMenuBar     *m_menuBar;       // Menu bar
-	ctlMenuToolbar     *m_toolBar;       // Frames' toolbar
-	wxMenu        *m_viewMenu;      // View menu (can be modified by wxCodeWindow)
-	wxMenu        *m_debugMenu;     // Debug menu (can be modified by wxCodeWindow)
+	ctlVarWindow *GetVarWindow(bool create)
+	{
+		return m_tabWindow->GetVarWindow(create);
+	}
+	ctlVarWindow *GetParamWindow(bool create)
+	{
+		return m_tabWindow->GetParamWindow(create);
+	}
+	ctlVarWindow *GetPkgVarWindow(bool create)
+	{
+		return m_tabWindow->GetPkgVarWindow(create);
+	}
+	ctlResultGrid *GetResultWindow()
+	{
+		return m_tabWindow->GetResultWindow();
+	}
+
+	void           DisplaySource(dbgCachedStack &);
 
-	wxAuiManager manager;
-	ctlCodeWindow   *m_standaloneDebugger;      // Standalone debugger window
-	dlgDirectDbg    *m_standaloneDirectDbg;     // Standalone direct debugger
+	void EnableToolsAndMenus(bool enable = true);
+	void UnhilightCurrentLine();
+	void HighlightLine(int _lineNo);
+	void ClearBreakpointMarkers();
+	void MarkBreakpoint(int lineNo);
+	void CloseProgressBar();
+	void LaunchWaitingDialog(const wxString &msg = wxEmptyString);
 
 private:
-	wxStatusBar    *m_statusBar;    // Frame's status bar
 
-	wxMenuBar    *setupMenuBar( void );
-	ctlMenuToolbar    *setupToolBar( void );
-	wxStatusBar  *setupStatusBar( void );
+	int  GetLineNo();
+	bool IsBreakpoint(int _lineNo);
+	void ClearAllBreakpoints();
 
-	frmMain *m_parent;
+	wxMenuBar      *SetupMenuBar( void );
+	ctlMenuToolbar *SetupToolBar( void );
+	wxStatusBar    *SetupStatusBar( void );
+
+	enum
+	{
+		MARKER_CURRENT    = 0x02,       // Current line marker
+		MARKER_CURRENT_BG = 0x04,       // Current line marker - background hilight
+		MARKER_BREAKPOINT = 0x01,       // Breakpoint marker
+	};
 
-	DECLARE_EVENT_TABLE()
 
-	void OnExecute( wxCommandEvent &event );
-	void OnDebugCommand( wxCommandEvent &event );
-	void OnSelectFrame( wxCommandEvent &event );
-	void OnMarginClick( wxStyledTextEvent &event );     // Set/clear breakpoint on margin click
-	void OnPositionStc( wxStyledTextEvent &event );
-	void OnVarChange( wxGridEvent &event );
-	void OnClose( wxCloseEvent &event );
-	void OnExit( wxCommandEvent &event );
-	void OnSize( wxSizeEvent &event );
-	void OnEraseBackground(wxEraseEvent &event);
-	void OnHelp(wxCommandEvent &event);
-	void OnContents(wxCommandEvent &event);
-
-	void OnToggleToolBar(wxCommandEvent &event);
-	void OnToggleStackPane(wxCommandEvent &event);
-	void OnToggleOutputPane(wxCommandEvent &event);
-	void OnAuiUpdate(wxAuiManagerEvent &event);
-	void OnDefaultView(wxCommandEvent &event);
+private:
+	// Menu bar
+	wxMenuBar      *m_menuBar;
+	// Frames' toolbar
+	ctlMenuToolbar *m_toolBar;
+	// View menu (can be modified by wxCodeWindow)
+	wxMenu         *m_viewMenu;
+	// Debug menu (can be modified by wxCodeWindow)
+	wxMenu         *m_debugMenu;
+
+	wxAuiManager    m_manager;
+	// Frame's status bar
+	wxStatusBar    *m_statusBar;
+	// Main Frame
+	frmMain        *m_parent;
+	// Debugger Controller
+	dbgController  *m_controller;
+
+	// Stack Window
+	ctlStackWindow *m_stackWindow;
+	// Tab Window
+	ctlTabWindow   *m_tabWindow;
+	// Function Code Viewer
+	ctlSQLBox      *m_codeViewer;
+	// Timer
+	wxTimer         m_timer;
+	// "Waiting for target" dialog
+	wxProgressDialog *m_progressBar;
+
+	DECLARE_EVENT_TABLE()
 
+	// Idle processor
+	void OnTimer(wxTimerEvent &_ev);
+
+	void OnExecute(wxCommandEvent &_ev);
+	void OnDebugCommand(wxCommandEvent &_ev);
+	void OnSelectFrame(wxCommandEvent &_ev);
+	// Toggle break-point on margin click
+	void OnMarginClick(wxStyledTextEvent &_ev);
+	void OnPositionStc(wxStyledTextEvent &_ev);
+	void OnVarChange(wxGridEvent &_ev);
+	void OnClose(wxCloseEvent &_ev);
+	void OnExit(wxCommandEvent &_ev);
+	void OnSize(wxSizeEvent &_ev);
+	void OnEraseBackground(wxEraseEvent &_ev);
+	void OnHelp(wxCommandEvent &_ev);
+	void OnContents(wxCommandEvent &_ev);
+
+	void OnToggleToolBar(wxCommandEvent &_ev);
+	void OnToggleStackPane(wxCommandEvent &_ev);
+	void OnToggleOutputPane(wxCommandEvent &_ev);
+	void OnAuiUpdate(wxAuiManagerEvent &_ev);
+	void OnDefaultView(wxCommandEvent &_ev);
 };
 
 #endif
diff --git a/pgadmin/include/debugger/module.mk b/pgadmin/include/debugger/module.mk
index 1ce5bce..9dc8ad6 100644
--- a/pgadmin/include/debugger/module.mk
+++ b/pgadmin/include/debugger/module.mk
@@ -10,19 +10,15 @@
 #######################################################################
 
 pgadmin3_SOURCES += \
-	include/debugger/ctlCodeWindow.h \
+	include/debugger/dbgController.h \
+	include/debugger/dbgModel.h \
 	include/debugger/ctlMessageWindow.h \
 	include/debugger/ctlResultGrid.h \
 	include/debugger/ctlStackWindow.h \
 	include/debugger/ctlTabWindow.h \
 	include/debugger/ctlVarWindow.h \
 	include/debugger/dbgBreakPoint.h \
-	include/debugger/dbgConnProp.h \
 	include/debugger/dbgConst.h \
-	include/debugger/dbgDbResult.h \
-	include/debugger/dbgPgConn.h \
-	include/debugger/dbgPgThread.h \
- 	include/debugger/dbgResultset.h \
 	include/debugger/dbgTargetInfo.h \
  	include/debugger/debugger.h \
 	include/debugger/dlgDirectDbg.h \
diff --git a/pgadmin/include/frm/frmQuery.h b/pgadmin/include/frm/frmQuery.h
index 1f35a78..a5cd06a 100644
--- a/pgadmin/include/frm/frmQuery.h
+++ b/pgadmin/include/frm/frmQuery.h
@@ -13,6 +13,7 @@
 #define __FRM_QUERY_H
 
 #include "ctl/ctlAuiNotebook.h"
+#include "db/pgQueryResultEvent.h"
 #include "dlg/dlgClasses.h"
 #include "gqb/gqbViewController.h"
 #include "gqb/gqbModel.h"
@@ -222,7 +223,7 @@ private:
 	void OpenLastFile();
 	void updateMenu(bool allowUpdateModelSize = true);
 	void execQuery(const wxString &query, int resultToRetrieve = 0, bool singleResult = false, const int queryOffset = 0, bool toFile = false, bool explain = false, bool verbose = false);
-	void OnQueryComplete(wxCommandEvent &ev);
+	void OnQueryComplete(pgQueryResultEvent &ev);
 	void completeQuery(bool done, bool explain, bool verbose);
 	void OnScriptComplete(wxCommandEvent &ev);
 	void setTools(const bool running);
diff --git a/pgadmin/include/precomp.h b/pgadmin/include/precomp.h
index 3040ebd..3defe6c 100644
--- a/pgadmin/include/precomp.h
+++ b/pgadmin/include/precomp.h
@@ -46,21 +46,18 @@
 
 #include "db/pgConn.h"
 #include "db/pgQueryThread.h"
+#include "db/pgQueryResultEvent.h"
 #include "db/pgSet.h"
 
-#include "debugger/ctlCodeWindow.h"
 #include "debugger/ctlMessageWindow.h"
 #include "debugger/ctlResultGrid.h"
 #include "debugger/ctlStackWindow.h"
 #include "debugger/ctlTabWindow.h"
 #include "debugger/ctlVarWindow.h"
 #include "debugger/dbgBreakPoint.h"
-#include "debugger/dbgConnProp.h"
 #include "debugger/dbgConst.h"
-#include "debugger/dbgDbResult.h"
-#include "debugger/dbgPgConn.h"
-#include "debugger/dbgPgThread.h"
-#include "debugger/dbgResultset.h"
+#include "debugger/dbgController.h"
+#include "debugger/dbgModel.h"
 #include "debugger/dbgTargetInfo.h"
 #include "debugger/debugger.h"
 #include "debugger/dlgDirectDbg.h"
diff --git a/pgadmin/pgAdmin3.vcxproj b/pgadmin/pgAdmin3.vcxproj
index 521b1e1..5a1800c 100644
--- a/pgadmin/pgAdmin3.vcxproj
+++ b/pgadmin/pgAdmin3.vcxproj
@@ -1007,17 +1007,15 @@
       </PrecompiledHeader>
     </ClCompile>
     <ClCompile Include="utils\utffile.cpp" />
-    <ClCompile Include="debugger\ctlCodeWindow.cpp" />
     <ClCompile Include="debugger\ctlMessageWindow.cpp" />
     <ClCompile Include="debugger\ctlResultGrid.cpp" />
     <ClCompile Include="debugger\ctlStackWindow.cpp" />
     <ClCompile Include="debugger\ctlTabWindow.cpp" />
     <ClCompile Include="debugger\ctlVarWindow.cpp" />
     <ClCompile Include="debugger\dbgBreakPoint.cpp" />
-    <ClCompile Include="debugger\dbgDbResult.cpp" />
-    <ClCompile Include="debugger\dbgPgConn.cpp" />
-    <ClCompile Include="debugger\dbgPgThread.cpp" />
-    <ClCompile Include="debugger\dbgResultset.cpp" />
+    <ClCompile Include="debugger\dbgController.cpp" />
+    <ClCompile Include="debugger\dbgEvents.cpp" />
+    <ClCompile Include="debugger\dbgModel.cpp" />
     <ClCompile Include="debugger\dbgTargetInfo.cpp" />
     <ClCompile Include="debugger\debugger.cpp" />
     <ClCompile Include="debugger\dlgDirectDbg.cpp" />
@@ -1689,20 +1687,17 @@
     <ClInclude Include="include\schema\pgView.h" />
     <ClInclude Include="include\db\pgConn.h" />
     <ClInclude Include="include\db\pgQueryThread.h" />
+    <ClInclude Include="include\db\pgQueryResultEvent.h" />
     <ClInclude Include="include\db\pgSet.h" />
-    <ClInclude Include="include\debugger\ctlCodeWindow.h" />
     <ClInclude Include="include\debugger\ctlMessageWindow.h" />
     <ClInclude Include="include\debugger\ctlResultGrid.h" />
     <ClInclude Include="include\debugger\ctlStackWindow.h" />
     <ClInclude Include="include\debugger\ctlTabWindow.h" />
     <ClInclude Include="include\debugger\ctlVarWindow.h" />
     <ClInclude Include="include\debugger\dbgBreakPoint.h" />
-    <ClInclude Include="include\debugger\dbgConnProp.h" />
     <ClInclude Include="include\debugger\dbgConst.h" />
-    <ClInclude Include="include\debugger\dbgDbResult.h" />
-    <ClInclude Include="include\debugger\dbgPgConn.h" />
-    <ClInclude Include="include\debugger\dbgPgThread.h" />
-    <ClInclude Include="include\debugger\dbgResultset.h" />
+    <ClInclude Include="include\debugger\dbgController.h" />
+    <ClInclude Include="include\debugger\dbgModel.h" />
     <ClInclude Include="include\debugger\dbgTargetInfo.h" />
     <ClInclude Include="include\debugger\debugger.h" />
     <ClInclude Include="include\debugger\dlgDirectDbg.h" />
@@ -2239,4 +2234,4 @@
   <ImportGroup Label="ExtensionTargets">
     <Import Project="..\pgAdmin3.targets" />
   </ImportGroup>
-</Project>
\ No newline at end of file
+</Project>
